package cn.com.infosec.crypto.tls;

import cn.com.infosec.crypto.Digest;
import cn.com.infosec.crypto.macs.HMac;
import cn.com.infosec.crypto.params.KeyParameter;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

public class TlsMac {
   private long seqNo;
   private HMac mac;

   protected TlsMac(Digest digest, byte[] key_block, int offset, int len) {
      TlsMac var10000 = this;
      TlsMac var10001 = this;
      super();
      this.mac = new HMac(digest);
      KeyParameter var5;
      var5 = new KeyParameter.<init>(key_block, offset, len);
      var10001.mac.init(var5);
      var10000.seqNo = 0L;
   }

   protected int getSize() {
      return this.mac.getMacSize();
   }

   protected byte[] calculateMac(short type, byte[] message, int offset, int len) {
      TlsMac var10000;
      TlsMac var17;
      boolean var10001;
      ByteArrayOutputStream var10002;
      try {
         var10000 = this;
         var17 = this;
         var10002 = new ByteArrayOutputStream;
      } catch (IOException var12) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }

      ByteArrayOutputStream var5;
      ByteArrayOutputStream var10003 = var5 = var10002;

      byte[] var10004;
      int var10005;
      int var10006;
      int var10007;
      ByteArrayOutputStream var10008;
      ByteArrayOutputStream var10009;
      short var10010;
      ByteArrayOutputStream var10011;
      long var10012;
      try {
         var10004 = message;
         var10005 = offset;
         var10006 = len;
         var10007 = len;
         var10008 = var5;
         var10009 = var5;
         var10010 = type;
         var10011 = var5;
         var5.<init>();
         var10012 = this.seqNo;
      } catch (IOException var11) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }

      long type1 = var10012;
      ByteArrayOutputStream var10013 = var5;
      TlsMac var10014 = this;
      long var10015 = type1 + 1L;

      byte[] var18;
      try {
         var10014.seqNo = var10015;
         TlsUtils.writeUint64(var10012, var10013);
         TlsUtils.writeUint8(var10010, var10011);
         TlsUtils.writeVersion(var10009);
         TlsUtils.writeUint16(var10007, var10008);
         var10003.write(var10004, var10005, var10006);
         var18 = var10002.toByteArray();
      } catch (IOException var10) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }

      byte[] type2 = var18;

      HMac var19;
      try {
         var19 = var17.mac;
      } catch (IOException var9) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }

      var18 = type2;
      byte[] var20 = type2;
      byte type3 = 0;

      byte[] var16;
      try {
         var19.update(var18, type3, var20.length);
         var16 = new byte[var10000.mac.getMacSize()];
      } catch (IOException var8) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }

      type2 = var16;

      try {
         var17 = this;
         this.mac.doFinal(type2, 0);
      } catch (IOException var7) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }

      try {
         var17.mac.reset();
         return var16;
      } catch (IOException var6) {
         var10001 = false;
         throw new IllegalStateException("Internal error during mac calculation");
      }
   }
}
